local MwSound = false
local LsSound = false
local shockId = { fls = 8050, frs = 8056, es = 8042,}
local TeFirstTtLearn = { [1] = 3599, [2] = 8075, [3] = 5394, [4] = 8512, }
local buffTotem = {
	"8075", --strength of earth
	"8227", --flametongue
	"8512", --windfury
	"8177", --grounding
	"5675", --manaspring
	"8071", --stoneskin
	"8184", --elemental resistance
	"87718",--tranquil mind
	"3738", --wrath of air
}
local unitid = { "player", "pet", "target", "focus", "mouseover", "npc", "party", "partypet", "raid", "raidpet", }
local spellavalaible, lavasurgetime = 0,0
local spellbutton = { [73683] = { [8050] = {}, [51505] = {}, [1535] = {}, }, [73685] = { [1064] = {}, [77472] = {}, }, }

function TeOnLoad()
	if IsShaman() then
		TeDefaultFrame:RegisterEvent("ADDON_LOADED")
		TeDefaultFrame:RegisterEvent("UNIT_COMBAT")
		TeDefaultFrame:RegisterEvent("UNIT_AURA")
		TeDefaultFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
		TeDefaultFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
		TeDefaultFrame:RegisterEvent("PLAYER_TOTEM_UPDATE")
		TeDefaultFrame:RegisterEvent("ACTIONBAR_SLOT_CHANGED")
		TeDefaultFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
		TeDefaultFrame:RegisterEvent("LEARNED_SPELL_IN_TAB")
		TeDefaultFrame:RegisterEvent("UNIT_SPELLCAST_SENT")
		TeDefaultFrame:RegisterEvent("SPELL_UPDATE_COOLDOWN")
		TeDefaultFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		TeDefaultFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	else
		DisableAddOn("TribalEnhancement")
	end
end

function TeOnUpdate()
	if IsShaman() then
		if not CurrentSpec and UnitLevel("player") >= 10 then
			CurrentSpec = TeGetCurrentSpec()
			OrderDebuffFrame()
		end
		if not GetTalentInfo(3, 17) then OrderDebuffFrame() end
		if TeOptions.Ls.On and TeOptions.Ls.Ooc then LsTrack() end
		if TeOptions.Weapon.On and TeOptions.Weapon.Ooc then WeaponTrack() end
	end
end

function TeOnEvent(event, ...)
	if IsShaman() then
		if event == "ADDON_LOADED" then
			if ... == "TribalEnhancement" then
				TeInitializeOptions() 
			end
		end
		if (event == "UNIT_COMBAT" or event == "UNIT_AURA" or event == "PLAYER_TOTEM_UPDATE" or event == "PLAYER_REGEN_DISABLED" or event == "ACTIONBAR_SLOT_CHANGED" or event == "PLAYER_TARGET_CHANGED" or event == "SPELL_UPDATE_COOLDOWN") and IsInCombat() and not UnitInVehicle("player") then
			if not TeOptions.Lock then TeLockFrame() end
			if TeOptions.Mw.On and CurrentSpec == "enhanc" then MwTrack() end
			if TeOptions.Tw.On and CurrentSpec == "resto" then TwTrack() end
			if TeOptions.Lb.On and CurrentSpec == "elem" then LbTrack() end
			if TeOptions.Ss.On and CurrentSpec == "enhanc" then SsTrack() end
			if CurrentSpec == "resto" then
				if TeOptions.Eshi.On then EsTrack() end
			else
				if TeOptions.Shock.On then ShockTrack() end
			end
			if TeOptions.Ls.On then LsTrack() end
			if TeOptions.Purge.On then PurgeTrack() end
			if TeOptions.Tt.On then TtTrack() end
			if TeOptions.Weapon.On then WeaponTrack() end
			if TeOptions.Ue.On and SpellUsable(73680) then UnleashElementsTrack() end
		end
		if (event == "PLAYER_REGEN_ENABLED" or UnitInVehicle("player")) and TeOptions.Lock then
			TeflameFrame:Hide()
			TeflameFrame.ag:Stop()
			for i=1, 5 do
				TeMwFrame.texture[i]:Hide()
			end
			for k, v in pairs(TeDebuffFrame) do
				if k ~= 0 then
					if (k == "ls" and not TeOptions.Ls.Ooc) or k ~= "ls" then TeDebuffFrame[k]:Hide() end
				end
			end
			if not TeOptions.Weapon.Ooc then
				TeWeaponFrame.mh:Hide()
				TeWeaponFrame.oh:Hide()
			end
			for i=1, 4 do
				TeTtFrame.totem[i]:Hide()
				_G["MultiCastActionButton"..i.."Icon"]:SetVertexColor(1, 1, 1, 1)
				_G["MultiCastActionButton"..i.."State"] = false
			end
			for k, v in pairs(spellbutton) do
				for k1, v1 in pairs(v) do
					for k2, v2 in pairs(v1) do
						if v2.teoverlay then
							v2.teoverlay.ag:Stop()
							v2.teoverlay:Hide()
						end
					end
				end
			end
			MwSound = false
			LsSound = false
		end
		if event == "LEARNED_SPELL_IN_TAB" then
			CurrentSpec = TeGetCurrentSpec()
			OrderDebuffFrame()
		end
		if event == "UNIT_SPELLCAST_SENT" then
			local arg1, arg2, _, arg4 = ...
			if arg1 == "player" then
				if string.lower(arg2) == string.lower(GetSpellInfo(974)) then
					teShieldTarget = arg4
--					if UnitName("player") == "Snuff" and UnitInRaid("player") then SendChatMessage(arg2.." sur "..arg4 ,"CHANNEL" ,nil ,"5"); end
				end
			end
		end
		if event == "COMBAT_LOG_EVENT_UNFILTERED" and CurrentSpec == "elem" and IsInCombat() and not UnitInVehicle("player") then
			local arg4 = select(4, ...)
			local arg9 = select(9, ...)
			if GetTime() - lavasurgetime > 10 then
				TeflameFrame:Hide()
				TeflameFrame.ag:Stop()
			end
			if arg4 == UnitName("player") and arg9 == 77762 then
				if TeOptions.Lsurge.On then
					lavasurgetime = GetTime()
					TeflameFrame:Show()
					TeflameFrame.ag:Stop()
					TeflameFrame.ag:Play()
					PlaySoundFile(TeOptions.Lsurge.Sound)
				end
				lavasurgeproc = true
			end
		end
		if event == "UNIT_SPELLCAST_SUCCEEDED" and CurrentSpec == "elem" and IsInCombat() and not UnitInVehicle("player") and TeOptions.Lsurge.On then
			local arg1 = select(1, ...)
			local arg5 = select(5, ...)
			if arg1 == "player" and arg5 == 51505 then
				TeflameFrame:Hide()
				TeflameFrame.ag:Stop()
			end
		end
	end
end

function MwTrack()
	local BuffActive, stack = IsBuffActive("player", 53817)
	if BuffActive then
		for j = 1, 5 do
			if stack == j then
				if j == 5 then
					TeMwFrame.ag:Play()
					for i=1, 5 do
						if TeOptions.Mw.EnableAnim then
							TeMwFrame.texture[i]:Show()
						end
					end
					if not MwSound and TeOptions.Mw.Sound then
						PlaySoundFile("Interface\\AddOns\\TribalEnhancement\\Sound\\"..TeOptions.Mw.Sound..".mp3")
					end
					MwSound = true
				else
					TeMwFrame.ag:Stop()
					for i=1, 5 do
						
						if i <= j then
							if TeOptions.Mw.EnableAnim then TeMwFrame.texture[i]:Show() end
						else
							TeMwFrame.texture[i]:Hide()
						end
					end
					MwSound = false
				end
			end
		end
	else
		for i=1, 5 do
			TeMwFrame.texture[i]:Hide()
		end
		MwSound = false
	end
end

function SsTrack()
	local DebuffActive, stack, expirationTime = IsDebuffActive("target", 17364)
	if not HaveValidTarget() then
		TeDebuffFrame.ss:Hide()
	elseif not DebuffActive and SpellUsable(17364) then
		TeDebuffFrame.ss:Show()
		TeDebuffFrame.ss.ag:Stop()
	elseif DebuffActive then
		if expirationTime - GetTime() <= TeOptions.DebuffFlashDelay or stack == 1 then
			TeDebuffFrame.ss:Show()
			TeDebuffFrame.ss.ag:Play()
		else
			TeDebuffFrame.ss:Hide()
			TeDebuffFrame.ss.ag:Stop()
		end
	end
end

function TwTrack()
	local BuffActive, stack, expirationTime = IsBuffActive("player", 53390)
	if not BuffActive and Twlearn() then
		TeDebuffFrame.tw:Show()
		TeDebuffFrame.tw.ag:Stop()
	elseif BuffActive then
		if expirationTime - GetTime() <= TeOptions.DebuffFlashDelay then
			TeDebuffFrame.tw:Show()
			TeDebuffFrame.tw.ag:Play()
		else
			TeDebuffFrame.tw:Hide()
			TeDebuffFrame.tw.ag:Stop()
		end
	end
end

function LbTrack()
	if SpellUsable(51505) then
		local start, duration, enable = GetSpellCooldown(51505)
		if start + duration - GetTime() >= 1.5 then
			spellavalaible = start + duration 
		end
		if lavasurgeproc then spellavalaible = 0 end
		if spellavalaible <= GetTime() then
			TeDebuffFrame.lb:Show()
			TeDebuffFrame.lb.ag:Stop()
			lavasurgeproc = false
		elseif spellavalaible - GetTime() <= TeOptions.DebuffFlashDelay and spellavalaible - GetTime() > 0 then
			TeDebuffFrame.lb:Show()
			TeDebuffFrame.lb.ag:Play()
		else
			TeDebuffFrame.lb:Hide()
		end
	end
end

function ShockTrack()
	local DebuffActive, _, expirationTime  = IsDebuffActive("target", shockId[TeOptions.Shock.Type])
	if not HaveValidTarget() then
		TeDebuffFrame.shock:Hide()
	elseif not DebuffActive and SpellUsable(shockId[TeOptions.Shock.Type]) then
		TeDebuffFrame.shock:Show()
		TeDebuffFrame.shock.ag:Stop()
	elseif DebuffActive then
		if expirationTime - GetTime() <= TeOptions.DebuffFlashDelay then
			TeDebuffFrame.shock:Show()
			TeDebuffFrame.shock.ag:Play()
		else
			TeDebuffFrame.shock:Hide()
			TeDebuffFrame.shock.ag:Stop()
		end
	end
end

function LsTrack()
	if CurrentSpec == "resto" then Shield2Track = 52127 else Shield2Track = 324 end
	local BuffActive, stack, expirationTime = IsBuffActive("player", Shield2Track)
	if not BuffActive and SpellUsable(Shield2Track) then
		TeDebuffFrame.ls:Show()
		TeDebuffFrame.ls.ag:Stop()
		if TeOptions.Ls.Sound ~= NONE and not LsSound and IsInCombat() then
			PlaySoundFile(TeOptions.Ls.Sound)
			LsSound = true
		end
	elseif BuffActive then
		if expirationTime - GetTime() <= 30 or stack == 1 then
			TeDebuffFrame.ls:Show()
			TeDebuffFrame.ls.ag:Play()
			LsSound = false
			if CurrentSpec == "elem" then
				for i=1, 5 do
					TeMwFrame.texture[i]:Hide()
				end
				MwSound = false
			end
		elseif stack == 9 and TeOptions.Ls.Fsp and IsInCombat() then
			if TeOptions.Mw.EnableAnim then
				TeMwFrame.ag:Play()
				for i=1, 5 do
					TeMwFrame.texture[i]:Show()
				end
			end
			if not MwSound and TeOptions.Mw.Sound then
				PlaySoundFile("Interface\\AddOns\\TribalEnhancement\\Sound\\"..TeOptions.Mw.Sound..".mp3")
				MwSound = true
			end
		else
			TeDebuffFrame.ls:Hide()
			TeDebuffFrame.ls.ag:Stop()
			LsSound = false
			if CurrentSpec == "elem" then
				for i=1, 5 do
					TeMwFrame.texture[i]:Hide()
				end
				MwSound = false
			end
		end
	end
end

function EsTrack()
	if teShieldTarget then
		local BuffActive, stack, expirationTime = IsBuffActive(teShieldTarget, 974)
		if BuffActive and (expirationTime - GetTime() <= TeOptions.DebuffFlashDelay or stack == 1) then
			TeDebuffFrame.eshi:Show()
			TeDebuffFrame.eshi.ag:Play()
		elseif BuffActive then
			TeDebuffFrame.eshi:Hide()	
		else
			TeDebuffFrame.eshi:Show()
			TeDebuffFrame.eshi.ag:Stop()
		end
	else
		for k, v in pairs(unitid) do
			if v == "party" or v == "partypet" then
				for i=1, 4 do
					if IsBuffActive(v..i, 974) then
						teShieldTarget = UnitName(v..i)
						EsTrack()
					end
				end
			elseif v == "raid" or v == "raidpet" then
				for i=1, 40 do
					if IsBuffActive(v..i, 974) then
						teShieldTarget = UnitName(v..i)
						EsTrack()
					end
				end
			else
				if IsBuffActive(v, 974) then
					teShieldTarget = UnitName(v)
					EsTrack()
				end
			end
		end
		if not teShieldTarget then TeDebuffFrame.eshi:Show() end
	end
end

function PurgeTrack()
	if IsBuffActive("target", nil) and HaveValidTarget() and SpellUsable(370) then
		TeDebuffFrame.purge:Show()
	else
		TeDebuffFrame.purge:Hide()
	end
end

function TtTrack()
	for i=1, 4 do
		local haveTotem, totemName, startTime, duration = GetTotemInfo(i)
		local ActionButtonIcon, ActionButtonState
		if i == 1 then
			ActionButtonIcon = MultiCastActionButton2Icon
		elseif i ==2 then
			ActionButtonIcon = MultiCastActionButton1Icon
		else
			ActionButtonIcon = _G["MultiCastActionButton"..i.."Icon"]
		end
		if TotemSlotEmpty(i) then
			TeTtFrame.totem[i]:Hide()
			TeTtFrame.totem[i].ag:Stop()
		elseif totemName ~= "" and (TotemInRange(totemName) or TeOptions.Tt.BuffCheckMode ~= "texture") then
			if TotemInRange(totemName) and TeOptions.Tt.BuffCheckMode == "bar" then
				ActionButtonIcon:SetVertexColor(1, 1, 1, 1)
				ActionButtonState = false
			elseif totemName and TeOptions.Tt.BuffCheckMode == "bar" then
				ActionButtonIcon:SetVertexColor(1, 0, 0, 1)
				ActionButtonState = true
			end
			if startTime + duration - GetTime() <= TeOptions.Tt.FlashDelay then
				TeTtFrame.totem[i]:Show()
				TeTtFrame.totem[i].ag:Play()
			else
				TeTtFrame.totem[i]:Hide()
				TeTtFrame.totem[i].ag:Stop()
			end
		else
			if SpellUsable(TeFirstTtLearn[i]) then
				TeTtFrame.totem[i]:Show()
				TeTtFrame.totem[i].ag:Stop()
				ActionButtonIcon:SetVertexColor(1, 1, 1, 1)
				ActionButtonState = false
			end
		end
		if i == 1 then
			 MultiCastActionButton2State = ActionButtonState
		elseif i ==2 then
			 MultiCastActionButton1State = ActionButtonState
		else
			 _G["MultiCastActionButton"..i.."State"] = ActionButtonState
		end
	end
end

function TotemInRange(totemName)
	if totemName then
		local _, _, ttIcon = GetSpellInfo(totemName)
		for k,v in pairs(buffTotem) do
			local _, _, bttIcon = GetSpellInfo(v)
			if bttIcon == ttIcon then
				if IsBuffActive("player", ttIcon) then
					return true
				else
					return false
				end
			end
		end
		return true
	end
end

function TotemSlotEmpty(slot)
	local _, spellID = GetActionInfo(128+(MultiCastActionBarFrame.currentPage*4)+slot)
	if not spellID then
		return true
	end
end

function WeaponTrack()
	local hasMainHandEnchant, mainHandExpiration, _, hasOffHandEnchant, offHandExpiration = GetWeaponEnchantInfo()
	if not hasMainHandEnchant and SpellUsable(8024) then
		TeWeaponFrame.mh:Show()
		TeWeaponFrame.mh.ag:Stop()
	elseif hasMainHandEnchant then
		if mainHandExpiration/1000 <= TeOptions.Weapon.FlashDelay then
			TeWeaponFrame.mh:Show()
			TeWeaponFrame.mh.ag:Play()
		else
			TeWeaponFrame.mh:Hide()
		end
	end
	if not hasOffHandEnchant and OffhandHasWeapon() and SpellUsable(8024) then
		TeWeaponFrame.oh:Show()
		TeWeaponFrame.oh.ag:Stop()
	elseif hasOffHandEnchant then
		if offHandExpiration/1000 <= TeOptions.Weapon.FlashDelay then
			TeWeaponFrame.oh:Show()
			TeWeaponFrame.oh.ag:Play()
		else
			TeWeaponFrame.oh:Hide()
		end
	end
end

function UnleashElementsTrack()
	for k, v in pairs(spellbutton) do
		local isactive, count, expirationtime = IsBuffActive("player", k)
		for k1, v1 in pairs(v) do
			for k2, v2 in pairs(v1) do
				if isactive then
					if v2:IsVisible() then
						teOverlay(v2)
						if expirationtime - GetTime() <= TeOptions.DebuffFlashDelay then
							v2.teoverlay.ag:Play()
						end
					elseif v2.teoverlay then
						v2.teoverlay:Hide()
						v2.teoverlay.ag:Stop()
					end
				else
					if v2.teoverlay then
						v2.teoverlay:Hide()
						v2.teoverlay.ag:Stop()
					end
				end
			end
		end
	end
end

function SpellUsable(spellid)
	local name = GetSpellInfo(spellid)
	local skillType, spellId = GetSpellBookItemInfo(name)
	if spellId then 
		return true
	else
		return false 
	end
end

function IsInCombat()
	if UnitAffectingCombat("player") then
		return true
	else
		return false
	end
end

function IsShaman()
	local _,PlayerClass = UnitClass("player")
	if PlayerClass == "SHAMAN" then
		return true
	else
		return false
	end
end

function HaveValidTarget()
	local name = GetSpellInfo(403)
	local inRange = IsSpellInRange(name, "target")
	if inRange == nil then
		return false
	else
		return true
	end
end

function IsBuffActive(myUnit, mySpell)
	local i = 1
	local name, _, icon, count, dispelType, _, expirationTime, unitCaster, _, _, spellId = UnitBuff(myUnit, i)
	while spellId do
		if not mySpell then
			if dispelType == "Magic" then return true end
		elseif spellId == mySpell and unitCaster == "player" then
			return true, count, expirationTime
		elseif icon == mySpell then
			return true
		end
		i = i + 1
		name, _, icon, count, dispelType, _, expirationTime, unitCaster, _, _, spellId = UnitBuff(myUnit, i)
	end
end

function IsDebuffActive(myUnit, mySpellId)
	local i = 1
	local _, _, _, count, _, _, expirationTime, unitCaster, _, _, spellId = UnitDebuff(myUnit, i)
	while spellId do
		if spellId == mySpellId and unitCaster == "player" then
			return true, count, expirationTime
		end
		i = i + 1
		_, _, _, count, _, _, expirationTime, unitCaster, _, _, spellId = UnitDebuff(myUnit, i)
	end
end

function TeGetCurrentSpec()
	local TeSpellTreeRef = { [974] = "resto", [60103] = "enhanc", [51490] = "elem", }
	for k, v in pairs(TeSpellTreeRef) do
		if SpellUsable(k) then
			return v
		end
	end
end

function Twlearn()
	local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(3, 17)
	if currentRank >= 1 then
		return true
	else
		return false
	end
end

function TeInitializeOptions()
	if not TeOptions or type(TeOptions.Version) ~= "string" then
		TeOptions = TeResetOptions()
	elseif  TeOptions.Version < "1.1.12" then
		TeUpdateOptions()
	end
	
	SLASH_TE1 = "/te"
	SlashCmdList["TE"] = TeCommand

	TeBuildUI()
	TeLockFrame()
	OrderDebuffFrame()
end

function TeResetOptions()
	local DefaultsOptions = {}
	DefaultsOptions = {
		Version = "1.1.12",
		Lock = true,
		BlizzMove = true,
		DebuffSize = 64,
		DebuffFlashDelay = 3,
		Mw = {
			On = true,
			EnableAnim = true,
			Sound = "Sample1",
			Size = 200,
			Texture = "TribalVector1",
			Color ={
				r = 0,
				v = 0,
				b = 0,
				a = 1,
			},
		},
		Lsurge = {
			On = true,
			Sound = "Sound\\Spells\\Ulduar_XT002_Lightbomb.wav",
			Scale = 100,
		},
		Ss = {
			On = true,
		},
		Shock = {
			On = true,
			Type = "fls",
		},
		Ls = {
			On = true,
			Sound = "Sound\\Spells\\ShaysBell.wav",
			Fsp = true,
			Ooc = false,
		},
		Eshi = {
			On = true,
		},
		Purge = {
			On = true,
		},
		Tw = {
			On = true,
		},
		Lb = {
			On = true,
		},
		Tt ={
			On = true,
			Radius = 80,
			Size = 64,
			BuffCheckMode = "bar",
			FlashDelay = 5,
		},
		Weapon ={
			On = true,
			Radius = 80,
			Size = 40,
			FlashDelay = 60,
			Ooc = false,
		},
		Ue = {
			On = true,
		},
	}
	return DefaultsOptions
end

function TeUpdateOptions()
	local DefaultsOptions = TeResetOptions()
	for k, v in pairs(DefaultsOptions) do
		if type(DefaultsOptions[k]) == "table" then
			if type(TeOptions[k]) ~= "table" then TeOptions[k] = {} end
			for k2, v2 in pairs(DefaultsOptions[k]) do
				if type(DefaultsOptions[k][k2]) == "table" then
					if type(TeOptions[k][k2]) ~= "table" then TeOptions[k][k2] = {} end
					for k3, v3 in pairs(DefaultsOptions[k][k2]) do
						if not TeOptions[k][k2][k3] then TeOptions[k][k2][k3] = v3 end
					end
				else
					if not TeOptions[k][k2] then TeOptions[k][k2] = v2 end
				end
			end
		else
			if k == "Version" then TeOptions[k] = v end
			if not TeOptions[k] then TeOptions[k] = v end
		end
	end
end

function TeCommand(msg)
	if msg == "run" then temyfunc() 
	elseif msg == "export" then StaticPopup_Show("SIM_EXPORT")
	elseif not IsInCombat() then InterfaceOptionsFrame_OpenToCategory(options.panel) else print(NOACCESINCOMBAT) end
end

function temyfunc()
	local numbnfriends = BNGetNumFriends()
	for i = 1, numbnfriends do
		print(BNGetFriendInfo(i))
	end
end

function ActionButton_UpdateCatch(self)
	if TeOptions.Ue.On and SpellUsable(73680) then
		local bname = self:GetName()
		local button = _G[self:GetName()]
		local slot = button.id or button.action
		local spellType, id, subType  = GetActionInfo(slot)
		for k, v in pairs(spellbutton) do
			for k1, v1 in pairs(v) do
				local match = nil
				for k2, v2 in pairs(v1) do 
					if v2 == button then match = 1 end
					local slot2 = v2.id or v2.action
					local _, spellid, _ = GetActionInfo(slot2)
					if spellid ~= k1 then
						table.remove(v1, k2)
						if v2.teoverlay then
							v2.teoverlay:Hide()
						end
					end
				end
				if id == k1 and not match then table.insert(v1, button) end
			end
		end
	end
end
hooksecurefunc("ActionButton_HideOverlayGlow", ActionButton_UpdateCatch)