if select(2, UnitClass("player")) ~= "SHAMAN" then return end

function TeBuildUI()
	TeMwFrame:Show()
	TeMwFrame:SetSize(TeOptions.Mw.Size, TeOptions.Mw.Size)
	TeMwFrame.texture = {}
	for i=1, 5 do
		TeMwFrame.texture[i] = TeMwFrame:CreateTexture()
		TeMwFrame.texture[i]:SetTexture("Interface\\AddOns\\TribalEnhancement\\Texture\\"..TeOptions.Mw.Texture.."_"..i..".tga")
		TeMwFrame.texture[i]:SetAllPoints(TeMwFrame)
		TeMwFrame.texture[i]:SetVertexColor(TeOptions.Mw.Color.r, TeOptions.Mw.Color.v, TeOptions.Mw.Color.b, TeOptions.Mw.Color.a)
	end
	TeFlashAnim(TeMwFrame)

	TeDebuffFrame:Show()
	TeDebuffFrame:SetSize(TeOptions.DebuffSize*4, TeOptions.DebuffSize)
	TeDebuffFrame.ss = TeDebuffFrame:CreateTexture()
	TeDebuffFrame.ss:SetTexture("Interface\\Icons\\Ability_Shaman_Stormstrike")
	TeDebuffFrame.ss:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.ss:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", 0, 0)
	TeFlashAnim(TeDebuffFrame.ss)
	
	TeDebuffFrame.tw = TeDebuffFrame:CreateTexture()
	TeDebuffFrame.tw:SetTexture("Interface\\Icons\\Spell_Shaman_TidalWaves")
	TeDebuffFrame.tw:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.tw:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", 0, 0)
	TeFlashAnim(TeDebuffFrame.tw)
	
	TeDebuffFrame.lb = TeDebuffFrame:CreateTexture()
	TeDebuffFrame.lb:SetTexture("Interface\\Icons\\Spell_Shaman_LavaBurst")
	TeDebuffFrame.lb:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.lb:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", 0, 0)
	TeFlashAnim(TeDebuffFrame.lb)
	
	local shockTexture = { fls = "Spell_Fire_FlameShock", frs = "Spell_Frost_FrostShock", es = "Spell_Nature_EarthShock",}
	TeDebuffFrame.shock = TeDebuffFrame:CreateTexture()
	TeDebuffFrame.shock:SetTexture("Interface\\Icons\\"..shockTexture[TeOptions.Shock.Type])
	TeDebuffFrame.shock:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.shock:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", TeOptions.DebuffSize, 0)
	TeFlashAnim(TeDebuffFrame.shock)
	
	TeDebuffFrame.ls = TeDebuffFrame:CreateTexture()
	TeDebuffFrame.ls:SetTexture("Interface\\Icons\\Spell_Nature_LightningShield")
	TeDebuffFrame.ls:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.ls:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", TeOptions.DebuffSize*2, 0)
	TeFlashAnim(TeDebuffFrame.ls)

	TeDebuffFrame.purge = TeDebuffFrame:CreateTexture()
	TeDebuffFrame.purge:SetTexture("Interface\\Icons\\Spell_Nature_Purge")
	TeDebuffFrame.purge:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.purge:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", TeOptions.DebuffSize*3, 0)
	
	TeDebuffFrame.eshi = TeDebuffFrame:CreateTexture()
	TeDebuffFrame.eshi:SetTexture("Interface\\Icons\\Spell_Nature_SkinofEarth")
	TeDebuffFrame.eshi:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.eshi:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", TeOptions.DebuffSize, 0)
	TeFlashAnim(TeDebuffFrame.eshi)
	
	TeTtFrame:Show()
	TeTtFrame:SetSize(TeOptions.Tt.Radius*2, TeOptions.Tt.Radius*2)
	TeTtFrame.totem = {}
	for i=1, 4 do
		TeTtFrame.totem[i] = TeTtFrame:CreateTexture()
		TeTtFrame.totem[i]:SetSize(TeOptions.Tt.Size, TeOptions.Tt.Size)
		TeTtFrame.totem[i]:SetTexture("Interface\\AddOns\\TribalEnhancement\\Texture\\TaurenTotem.tga")
		TeFlashAnim(TeTtFrame.totem[i])
	end
	TeTtFrame.totem[1]:SetPoint("CENTER", TeTtFrame, "TOPLEFT", -TeOptions.Tt.Radius, TeOptions.Tt.Radius)
	TeTtFrame.totem[1]:SetVertexColor(1, 0.4, 0)
	TeTtFrame.totem[2]:SetPoint("CENTER", TeTtFrame, "TOPRIGHT", TeOptions.Tt.Radius, TeOptions.Tt.Radius)
	TeTtFrame.totem[2]:SetVertexColor(0, 1, 0)
	TeTtFrame.totem[3]:SetPoint("CENTER", TeTtFrame, "BOTTOMRIGHT", TeOptions.Tt.Radius, -TeOptions.Tt.Radius)
	TeTtFrame.totem[3]:SetVertexColor(0, 1, 1)
	TeTtFrame.totem[4]:SetPoint("CENTER", TeTtFrame, "BOTTOMLEFT", -TeOptions.Tt.Radius, -TeOptions.Tt.Radius)
	TeTtFrame.totem[4]:SetVertexColor(0.5, 0.5, 1)

	TeWeaponFrame:Show()
	TeWeaponFrame:SetSize(TeOptions.Weapon.Radius*2, 90)
	TeWeaponFrame.mh = TeWeaponFrame:CreateTexture()
	TeWeaponFrame.mh:SetSize(TeOptions.Weapon.Size, TeOptions.Weapon.Size/40*90)
	TeWeaponFrame.mh:SetTexture("Interface\\Durability\\UI-Durability-Icons")
	TeWeaponFrame.mh:SetPoint("CENTER", TeWeaponFrame, "RIGHT", TeOptions.Weapon.Radius, 0)
	TeWeaponFrame.mh:SetTexCoord(0, 0.140625, 0.3203125, 0.6640625)
	TeFlashAnim(TeWeaponFrame.mh)
	
	TeWeaponFrame.oh = TeWeaponFrame:CreateTexture()
	TeWeaponFrame.oh:SetSize(TeOptions.Weapon.Size, TeOptions.Weapon.Size/40*90)
	TeWeaponFrame.oh:SetTexture("Interface\\Durability\\UI-Durability-Icons")
	TeWeaponFrame.oh:SetPoint("CENTER", TeWeaponFrame, "LEFT", -TeOptions.Weapon.Radius, 0)
	TeWeaponFrame.oh:SetTexCoord(0, 0.140625, 0.3203125, 0.6640625)
	TeFlashAnim(TeWeaponFrame.oh)
	
	LavaSurgeSetSize()
	TeflameFrame.texture = TeflameFrame:CreateTexture()
	TeflameFrame.texture:SetTexture("Textures\\SpellActivationOverlays\\Blood_Surge")
	TeflameFrame.texture:SetRotation(math.rad(-90))
	TeflameFrame.texture:SetAllPoints(TeflameFrame)
	TeScrolAnim(TeflameFrame)
	
	TeBlizzMove()
	
end

function TeScrolAnim(region)
	local ag = region:CreateAnimationGroup()
	local a1 = ag:CreateAnimation("Scale")
	a1:SetDuration(0.5)
	a1:SetOrder(1)
	a1:SetScale(1.1,1.1)
	local a2 = ag:CreateAnimation("Scale")
	a2:SetDuration(0.5)
	a2:SetOrder(2)
	a2:SetScale(10/11,10/11)
	region.ag = ag
	region.ag:SetLooping("REPEAT")
end

function TeFlashAnim(region, delay)
	if not delay then delay = 0.5 end
	local ag = region:CreateAnimationGroup()
	local a1 = ag:CreateAnimation("Alpha")
	a1:SetChange(-1)
	a1:SetDuration(delay)
	local a2 = ag:CreateAnimation("Alpha")
	a2:SetChange(1)
	a2:SetDuration(delay)
	a2:SetStartDelay(delay)
--	a2:SetEndDelay(delay)
	region.ag = ag
	region.ag:SetLooping("REPEAT")
end

function MwSetColor()
	for i=1, 5 do
		TeMwFrame.texture[i]:SetVertexColor(TeOptions.Mw.Color.r, TeOptions.Mw.Color.v, TeOptions.Mw.Color.b, TeOptions.Mw.Color.a)
	end
end

function MwSetTexture()
	for i=1, 5 do
		TeMwFrame.texture[i]:SetTexture("Interface\\AddOns\\TribalEnhancement\\Texture\\"..TeOptions.Mw.Texture.."_"..i..".tga")
	end
end

function MwSetSize()
	TeMwFrame:SetSize(TeOptions.Mw.Size, TeOptions.Mw.Size)
	for i=1, 5 do
		TeMwFrame.texture[i]:SetAllPoints(TeMwFrame)
	end
end

function LavaSurgeSetSize()
	TeflameFrame:SetSize(256/100*TeOptions.Lsurge.Scale, 128/100*TeOptions.Lsurge.Scale)
end

function TeLockFrame(arg1)
	if arg1 == "reset" then
		TeMwFrame:ClearAllPoints()
		TeDebuffFrame:ClearAllPoints()
		TeMwFrame:SetPoint("CENTER")
		TeDebuffFrame:SetPoint("CENTER", 0, -300)
		TeflameFrame:ClearAllPoints()
		TeflameFrame:SetPoint("CENTER", 0, 100)
	else
		for i=1, 5 do
			TeMwFrame.texture[i]:Hide()
		end
		TeMwFrame:EnableMouse(false)
		for k, v in pairs(TeDebuffFrame) do
			if k ~= 0 then TeDebuffFrame[k]:Hide() end
		end
		TeDebuffFrame:EnableMouse(false)
		for i=1,4 do
			TeTtFrame.totem[i]:Hide()
		end
		TeWeaponFrame.mh:Hide()
		TeWeaponFrame.oh:Hide()
		TeWeaponFrame:EnableMouse(false)
		TeTtFrame:EnableMouse(false)
		TeflameFrame:Hide()
		TeflameFrame:EnableMouse(false)
	end
end

function OrderDebuffFrame()
	TeDebuffFrame:SetSize(TeOptions.DebuffSize*4, TeOptions.DebuffSize)
	TeDebuffFrame.ss:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.tw:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.lb:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.shock:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.ls:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.eshi:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	TeDebuffFrame.purge:SetSize(TeOptions.DebuffSize, TeOptions.DebuffSize)
	local tedebuff = 0
	if TeOptions.Ss.On and SpellUsable(17364) then 
		TeDebuffFrame.ss:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", 0, 0)
		tedebuff = tedebuff +1
	end
	if TeOptions.Tw.On and Twlearn() then 
		TeDebuffFrame.tw:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", 0, 0)
		tedebuff = tedebuff +1
	end
	if TeOptions.Lb.On and SpellUsable(51505) and CurrentSpec == "elem" then 
		TeDebuffFrame.lb:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", 0, 0)
		tedebuff = tedebuff +1
	end
	if TeOptions.Shock.On and SpellUsable(8042) and CurrentSpec ~= "resto" then
		TeDebuffFrame.shock:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", TeOptions.DebuffSize*tedebuff, 0)
		tedebuff = tedebuff +1
	end
	if TeOptions.Eshi.On and SpellUsable(974) then
		TeDebuffFrame.eshi:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", TeOptions.DebuffSize*tedebuff, 0)
		tedebuff = tedebuff +1
	end
	if TeOptions.Ls.On and SpellUsable(324) then
		TeDebuffFrame.ls:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", TeOptions.DebuffSize*tedebuff, 0)
		tedebuff = tedebuff +1
		if CurrentSpec == "resto" then
			TeDebuffFrame.ls:SetTexture("Interface\\Icons\\Ability_Shaman_WaterShield")
		else
			TeDebuffFrame.ls:SetTexture("Interface\\Icons\\Spell_Nature_LightningShield")
		end
	end
	if TeOptions.Purge.On and SpellUsable(370) then
		TeDebuffFrame.purge:SetPoint("TOPLEFT", TeDebuffFrame, "TOPLEFT", TeOptions.DebuffSize*tedebuff, 0)
	end
end

function ShockSetTexture()
	local shockTexture = { fls = "Spell_Fire_FlameShock", frs = "Spell_Frost_FrostShock", es = "Spell_Nature_EarthShock",}
	TeDebuffFrame.shock:SetTexture("Interface\\Icons\\"..shockTexture[TeOptions.Shock.Type])
end

function WbSetRadius()
	TeWeaponFrame.mh:SetPoint("CENTER", TeWeaponFrame, "RIGHT", TeOptions.Weapon.Radius, 0)
	TeWeaponFrame.oh:SetPoint("CENTER", TeWeaponFrame, "LEFT", -TeOptions.Weapon.Radius, 0)
	TeWeaponFrame:SetSize(TeOptions.Weapon.Radius*2, 90)
end

function WpSetScale()
	TeWeaponFrame.mh:SetSize(TeOptions.Weapon.Size, TeOptions.Weapon.Size/40*90)
	TeWeaponFrame.oh:SetSize(TeOptions.Weapon.Size, TeOptions.Weapon.Size/40*90)
end

function TtSetRadius()
	TeTtFrame:SetSize(TeOptions.Tt.Radius*2, TeOptions.Tt.Radius*2)
	TeTtFrame.totem[1]:SetPoint("CENTER", TeTtFrame, "TOPLEFT", -TeOptions.Tt.Radius, TeOptions.Tt.Radius)
	TeTtFrame.totem[2]:SetPoint("CENTER", TeTtFrame, "TOPRIGHT", TeOptions.Tt.Radius, TeOptions.Tt.Radius)
	TeTtFrame.totem[3]:SetPoint("CENTER", TeTtFrame, "BOTTOMRIGHT", TeOptions.Tt.Radius, -TeOptions.Tt.Radius)
	TeTtFrame.totem[4]:SetPoint("CENTER", TeTtFrame, "BOTTOMLEFT", -TeOptions.Tt.Radius, -TeOptions.Tt.Radius)
end

function TtSetScale()
	for i=1, 4 do
		TeTtFrame.totem[i]:SetSize(TeOptions.Tt.Size, TeOptions.Tt.Size)
	end
end

function TeBlizzMove()
	if TeOptions.BlizzMove == true then
		InterfaceOptionsFrame:SetMovable(true)
		InterfaceOptionsFrame:SetScript("OnMouseDown", function ()
			if InterfaceOptionsFrame:IsMovable() then InterfaceOptionsFrame:StartMoving() end
		end)
		InterfaceOptionsFrame:SetScript("OnMouseUp", InterfaceOptionsFrame.StopMovingOrSizing)
	end
end

local function stopupdatevertex(self)
	if self:GetName() == "MultiCastActionButton1" or self:GetName() == "MultiCastActionButton2" or self:GetName() == "MultiCastActionButton3" or self:GetName() == "MultiCastActionButton4" then
		local name = self:GetName()
		local icon = _G[name.."Icon"]
		local state = _G[name.."State"]
		if state then
			icon:SetVertexColor(1, 0, 0, 1)
		end
	end
end
hooksecurefunc("ActionButton_UpdateUsable", stopupdatevertex)

function teOverlay(self)
	if self.teoverlay then
		if not self.teoverlay:IsVisible() then
			self.teoverlay:Show()
			self.teoverlay.animIn:Play()
		end
	else
		local name = self:GetName()
		self.teoverlay = CreateFrame("Frame", name.."TeOverlay", UIParent, "ActionBarButtonSpellActivationAlert")
		local frameWidth, frameHeight = self:GetSize();
        self.teoverlay:SetParent(self);
        self.teoverlay:ClearAllPoints();
        --Make the height/width available before the next frame:
        self.teoverlay:SetSize(frameWidth * 1.4, frameHeight * 1.4);
        self.teoverlay:SetPoint("TOPLEFT", self, "TOPLEFT", -frameWidth * 0.2, frameHeight * 0.2);
        self.teoverlay:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", frameWidth * 0.2, -frameHeight * 0.2);
        self.teoverlay.animIn:Play()
		TeFlashAnim(self.teoverlay,0.25)
	end
end
